EXTERN		DOUBLE                     acos( DOUBLE dv )  ; // arccos() , with errorhandling ;
EXTERN		DOUBLE                     acos_fast( DOUBLE dv )  ; // arccos() , fast ;
EXTERN		CHAR                      *addstr1_jcm( CHAR *ps , CHAR *pd )  ;
EXTERN		CHAR                      *addstr2_jcm( CHAR *ps , CHAR *pd , LONG *pcnt ) ;
EXTERN		CHAR                      *addstr_jcm( CHAR *ps1 , CHAR *pd1 ) ;
EXTERN		CHAR                      *addstrn_jcm( CHAR *ps , CHAR *pd , LONG cnt ) ;
EXTERN		BOOL                       am_i_hp_jcm( VOID )  ; // am i high priority ;
EXTERN		DOUBLE                     asin( DOUBLE dv )  ; // arcsin() , with errorhandling ;
EXTERN		DOUBLE                     asin_fast( DOUBLE dv )  ; // arcsin() , fast ;
EXTERN		DOUBLE                     atan( DOUBLE dv )  ; // arctan() , with errorhandling ;
EXTERN		DOUBLE                     atan2( DOUBLE yy , DOUBLE xx )  ; // arctan2( yy , xx ) , with errorhandling ;
EXTERN		LLONG                      atollnk_jcm( CHAR *adr , LONG ndp )  ; // ascii ( string ) to longlong ;
EXTERN		LONG                       atolnk_jcm( CHAR *adr , WORD ndp )  ; // asci ( string ) to long ;
EXTERN		DOUBLE                     bar2pascal( DOUBLE bar ) ;
EXTERN		DOUBLE                     bar2psi( DOUBLE bar ) ;
EXTERN		DOUBLE                     bar2torr( DOUBLE bar )  ; // torr = mmhg ;
EXTERN		ULONG                      bitrange_jcm( ULONG val , LONG first , LONG last )  ; // selecting and right-justifying some bits ;
EXTERN		DOUBLE                     bp_2l2d_jcm( LONG v1 , LONG v2 )  ; // bitpattern 2 longs -->> double ;
EXTERN		VOID                       bp_d22l_jcm( DOUBLE val , LONG *pv1 , LONG *pv2 )  ; // bitpattern double -->> 2 longs ;
EXTERN		LLONG                      bp_d2ll_jcm( DOUBLE val )  ; // bitpattern double -->> llong ;
EXTERN		LONG                       bp_highlong_jcm( DOUBLE dval )  ; // bit pattern : high 32 Bits -->> long ;
EXTERN		LONG                       bp_l2ul_jcm( LONG val )  ; // bitpattern long -->> ulong ;
EXTERN		DOUBLE                     bp_ll2d_jcm( LLONG val )  ; // bitpattern llong -->> double ;
EXTERN		VOID                       bp_ll2ll_jcm( LLONG v1 , LONG *plow , LONG *phigh )  ; // bit pattern : LLONG -->> 2 LONGS ;
EXTERN		LONG                       bp_lowlong_jcm( DOUBLE dval )  ; // bit pattern : low 32 Bits -->> long ;
EXTERN		DOUBLE                     bp_twolongs2double_jcm( ULONG high , ULONG low )  ; // bit pattern : low long , high long -->> double ;
EXTERN		ULLONG                     bp_twolongs2ullong_jcm( LONG high , LONG low )  ; // bit pattern : low long , high long -->> ULLONG ;
EXTERN		ULLONG                     bp_twoulongs2ullong_jcm( ULONG high , ULONG low )  ; // bit pattern : low ulong , high ulong -->> ULLONG ;
EXTERN		LONG                       bp_ul2l_jcm( ULONG val )  ; // bitpattern ulong -->> long ;
EXTERN		VOID                       bp_ull2ulul_jcm( ULLONG v1 , ULONG *plow , ULONG *phigh )  ; // bit pattern : ULLONG -->> 2 ULONGS ;
EXTERN		DOUBLE                     cbrt( DOUBLE xx)  ; // cuberoot ;
EXTERN		DOUBLE                     ceil( DOUBLE vv ) ;
EXTERN		DOUBLE                     celsius2fahrenheit( DOUBLE temp_celsius ) ;
EXTERN		LONG                       clamp_datanr_jcm( LONG dnr )  ; // retval : clamped dnr to [1;200] ;
EXTERN		VOID                       cmd2pc_jcm( LONG vv ) ;
EXTERN		BOOL                       cmpmem_jcm( VOID *ps , VOID *pd , LONG cnt )  ; // compare memory ( slow ) ;
EXTERN		BOOL                       cmpstr_jcm( CHAR *p1 , CHAR *p2 )  ; // compare strings; if equal return TRUE , else FALSE ( slow ) ;
EXTERN		BOOL                       cmpstrn_jcm( CHAR *p1 , CHAR *p2 , LONG cnt )  ; // compare strings , max. cnt characters ; equal: retval TRUE ; differ: FALSE ( slow ) ;
EXTERN		BOOL                       configok_jcm( VOID )  ; // Check configuration error: retval = FALSE ; all o.k. retval = TRUE ;
EXTERN		DOUBLE                     cos( DOUBLE dd )  ; // cosine ;
EXTERN		DOUBLE                     cosh( DOUBLE vv )  ; // hyperbolic cosine ;
EXTERN		LONG                       cp2ns_jcm( LONG cnt )  ; // clock pulses to nsec ;
EXTERN		CHAR                      *cpymem_jcm( VOID *ps , VOID *pd , LONG cnt )  ; // copy memory ( slow ) ;
EXTERN		DOUBLE                     cube( DOUBLE vv )  ; // vv *vv *vv ;
EXTERN		DOUBLE                     d_pow2( DOUBLE manti , DOUBLE expo )  ; // ?????? ;
EXTERN		DOUBLE                     dabs( DOUBLE dv )  ; // absolute value ;
EXTERN		VOID                      *data_ptr2malloc_ptr_jcm( VOID *dptr ) ;
EXTERN		VOID                       data_transfer_jcm( LONG dnr_s , LONG dnr_d )  ; // copy data with type conversion ;
EXTERN		VOID                       debug_printf( const CHAR *fmt, ...) ;
EXTERN		DOUBLE                     deg2rad( DOUBLE angle_degree )  ; // degrees to radians ;
EXTERN		BOOL                       diagnose_enabled_jcm( VOID )  ; // retval enable_diagnose_flag ;
EXTERN		BOOL                       diagnose_ptr_ok_jcm( VOID )  ; // pointer for c-info/errorhandling... ok ???? ;
EXTERN		LONG                       diff_tstamp_hr_jcm( LONG index )  ; // difference actual time - ( time stamp ) ; high resolution ( nsec ) ;
EXTERN		LONG                       diff_tstamp_lr_jcm( LONG index )  ; // difference actual time - ( time stamp ) ; low resolution ( sec ) ;
EXTERN		LONG                       diffindex_jcm( CHAR *p1 , CHAR *p2 )  ; // find index, where strings differ ;
EXTERN		VOID                       dirac1_jcm( DOUBLE *pdest , LONG nos_time_domain )  ; // pos-dirac at index( nos_time_domain/2) ; neg-dirac at index( 1 nos_time_domain/2) ;
EXTERN		VOID                       dirac_jcm( DOUBLE *pdest , LONG nos_time_domain )  ; // pos-dirac at index1 ; neg-dirac at index( 1 nos_time_domain) ;
EXTERN		VOID                       disable_diagnose_jcm( VOID )  ; // reset enable_diagnose_flag ;
EXTERN		DOUBLE                     div_double( DOUBLE num , DOUBLE denom )  ; // divide doubles ;
EXTERN		ULONG                      dt_now2t0_jcm( VOID )  ; // delta time ; now - t0 ;
EXTERN		DOUBLE                     exp( DOUBLE dv ) ;
EXTERN		DOUBLE                     exp_fast( DOUBLE dv ) ;
EXTERN		DOUBLE                     fabs( DOUBLE dv )  ; // absolute value ;
EXTERN		DOUBLE                     fahrenheit2celsius( DOUBLE temp_fahrenheit ) ;
EXTERN		DOUBLE                     fakul1( LONG vv )  ; // returns ( vv! ) ; fakul1( 5 ) = 5*4*3*2*1 ;
EXTERN		VOID                       fdummy_false_jcm( VOID )  ; // sets long_status_jcm to FALSE ;
EXTERN		VOID                       fdummy_jcm( VOID )  ; // dummy function ;
EXTERN		VOID                       fdummy_long_jcm( LONG vv )  ; // sets long_status_jcm to vv ;
EXTERN		VOID                       fdummy_true_jcm( VOID )  ; // sets long_status_jcm to TRUE ;
EXTERN		DOUBLE                     feet2meter( DOUBLE feet ) ;
EXTERN		DOUBLE                     floor( DOUBLE vv ) ;
EXTERN		DOUBLE                     fmod( DOUBLE aa , DOUBLE bb ) ;
EXTERN		DOUBLE                     frac_part( DOUBLE dv , DOUBLE *pdi ) ;
EXTERN		DOUBLE                     frexp( DOUBLE num , INT *pexp ) ;
EXTERN		LONG                       get_cpu_fpga_version_jcm( VOID )  ; // cpu-fpga-Version ;
EXTERN		LONG                       get_evcnt_jcm( LONG procno )  ; // get event count ;
EXTERN		CHAR                      *get_info_fct_jcm( VOID )  ; // get function info for error messages ;
EXTERN		CHAR                      *get_info_file_jcm( VOID )  ; // get file info for error messages ;
EXTERN		LONG                       get_info_line_jcm( VOID )  ; // get line info for error messages ;
EXTERN		LONG                       get_long_status_jcm( VOID )  ; // gets long_status_jcm ;
EXTERN		DOUBLE                     get_pi_jcm( VOID )  ; // returns PI ;
EXTERN		LONG                       get_t0_jcm( VOID )  ; // get t0 ;
EXTERN		LONG                       get_uptime_jcm( VOID )  ; // get uptime in secs ;
EXTERN		LONG                       getbtlrev_jcm( VOID )  ; // btl-revision ;
EXTERN		LONG                       getcpufreq_jcm( VOID )  ; // CPU-Frequenz, ;
EXTERN		LONG                       getcpuratio_jcm( VOID )  ; // CPU-pll-ratio, ;
EXTERN		LONG                       getddr3freq_jcm( VOID )  ; // DDR-Frequenz, ;
EXTERN		LONG                       getddr3ratio_jcm( VOID )  ; // DDR-pll-ratio, ;
EXTERN		LONG                       getentrycount_jcm( VOID )  ; // get number of C-entries ( errors , warnings , hints ... ) ;
EXTERN		LONG                       geterrorcount_jcm( VOID )  ; // get number of C-errorentries ;
EXTERN		DOUBLE                     getfpar_jcm( LONG ii )  ; // get FParameter ;
EXTERN		LONG                       getfreemem_c_jcm( VOID ) ;
EXTERN		LONG                       getfreemem_jcm( LONG location ) ;
EXTERN		LONG                       getfreemem_uc_jcm( VOID ) ;
EXTERN		LONG                       getiofreq_jcm( VOID )  ; // io-Frequenz, ;
EXTERN		LONG                       getioratio_jcm( VOID )  ; // io-pll-ratio, ;
EXTERN		CHAR                      *getlibmodifdate_jcm( CHAR *pdest ) ;
EXTERN		LONG                       getlibmodifrev_jcm( VOID ) ;
EXTERN		CHAR                      *getlibmodiftime_jcm( CHAR *pdest ) ;
EXTERN		LONG                       getmemavl_uc_jcm( VOID ) ;
EXTERN		LONG                       getmemlarg_uc_jcm( VOID ) ;
EXTERN		LONG                       getpar_jcm( LONG ii )  ; // get Parameter ;
EXTERN		LONG                       getprocdel_jcm( LONG pnr )  ; // get process delay ;
EXTERN		DOUBLE                     gr_or_0_jcm( DOUBLE vv )  ; // is vv greater than zero or zero; retval=-1 @ < 0 ;  1 @ >= 0 ;
EXTERN		DOUBLE                     hypot( DOUBLE v1 , DOUBLE v2 )  ; // equiv. sqrt( v1 *v1   v2 *v2 ) ;
EXTERN		DOUBLE                     inch2mm( DOUBLE inch ) ;
EXTERN		VOID                       init_max_jcm( DOUBLE *perg ) /*Init trackmax_jcm variable */ ;
EXTERN		LONG                       ipow( LONG base, LONG exp) ;
EXTERN		BOOL                       is_proc_hp_jcm( LONG pnr )  ; // is proc high priority ;
EXTERN		LONG                       isinf_jcm( DOUBLE xx ) ;
EXTERN		LONG                       isnan_inf_jcm( DOUBLE xx ) ;
EXTERN		LONG                       isnan_jcm( DOUBLE xx )  ; // ret-val 1 ist NaN ;
EXTERN		LONG                       isnum_jcm( DOUBLE xx )  ; // ret-val 1 ist Double-Wert ;
EXTERN		BOOL                       ist0valid_jcm( VOID )  ; // is t0 valid ;
EXTERN		CHAR                      *l2str_hex_jcm( ULONG val , CHAR *pdest )  ; // ULONG -->> hex-string with leading 0x ;
EXTERN		CHAR                      *l2str_jcm( LONG value , LONG ndp , LONG length , CHAR *pdest )  ; // LONG -->> string ( asci ) ndp = n_decimal_places ;
EXTERN		DOUBLE                     ldexp( DOUBLE mantis , INT expo )  ; // returns ( mantis *2^expo ) ;
EXTERN		CHAR                      *ll2str_hex_jcm( LLONG val , CHAR *pd )  ; // LLONG -->> hex-String without leading 0x ;
EXTERN		CHAR                      *ll2str_jcm( LLONG value , LONG ndp , LONG length , CHAR *pdest )  ; // LLONG -->> string ( asci ) ;
EXTERN		DOUBLE                     ln( DOUBLE vv )  ; // natural logarithm ( base e = 2,718281828459045.. ) ;
EXTERN		DOUBLE                     ln_fast( DOUBLE vv )  ; // natural logarithm ( base e = 2,718281828459045.. ) ;
EXTERN		DOUBLE                     log( DOUBLE vv )  ; // natural logarithm ( base e = 2,718281828459045.. ) ;
EXTERN		DOUBLE                     log10( DOUBLE vv )  ; // base 10 logrithm ;
EXTERN		DOUBLE                     log10_fast( DOUBLE vv )  ; // base 10 logrithm ;
EXTERN		DOUBLE                     log2i( DOUBLE vv )  ; // base 2 logrithm ;
EXTERN		DOUBLE                     log2i_fast( DOUBLE vv )  ; // base 2 logrithm ;
EXTERN		DOUBLE                     log_fast( DOUBLE vv )  ; // natural logarithm ( base e = 2,718281828459045.. ) ;
EXTERN		VOID                       makbig_jcm( CHAR *ps , CHAR *pd ) /*String to upper case */ ;
EXTERN		VOID                       maklit_jcm( CHAR *ps , CHAR *pd ) /*String to lower case */ ;
EXTERN		CHAR                      *memchr_jcm( CHAR *ps , INT cc , ULONG cnt )  ; // reference function for memchr tests ( slowly ) ;
EXTERN		VOID                       memdump2rs232_jcm( CHAR *pstart , LONG cnt )  ; // memory dump to rs232 ;
EXTERN		LONG                       memptr2cacheable1_jcm( ULONG adr ) ;
EXTERN		LONG                       memptr2size1_jcm( ULONG adr ) ;
EXTERN		DOUBLE                     meter2mile( DOUBLE meter ) ;
EXTERN		DOUBLE                     meter2nautm( DOUBLE mtr ) ;
EXTERN		DOUBLE                     mile2meter( DOUBLE mile ) ;
EXTERN		DOUBLE                     mm2inch( DOUBLE mm ) ;
EXTERN		LONG                       msg_index_data_jcm( LONG dnr , LONG nn , CHAR *pfi , CHAR *pfu , LONG li ) ;
EXTERN		VOID                       msleep_jcm( ULONG msec ) ;
EXTERN		DOUBLE                     nautm2meter( DOUBLE sm ) ;
EXTERN		DOUBLE                     nexttoward( DOUBLE xx , DOUBLE yy )  ; // nexttoward ;
EXTERN		VOID                       ns_sleep_jcm( LONG ncp ) ;
EXTERN		DOUBLE                     nterr_jcm( DOUBLE xx )  ; // numtest-error ;
EXTERN		DOUBLE                     pascal2bar( DOUBLE p_pascal ) ;
EXTERN		LONG                       pe3tmax_jcm( CHAR *pfi , CHAR *pfu , LONG line , DOUBLE val1 , DOUBLE val2 , DOUBLE erg , CHAR *pcomm , LONG mode , LONG enr)  ; // put error 3 , tmax ;
EXTERN		VOID                       posinfoclr_jcm( VOID )  ; // clear position info for error messages ;
EXTERN		LONG                       posinfoset_jcm( CHAR *pfi , CHAR *pfu , LONG li )  ; // set position info for error messages ;
EXTERN		VOID                       post_event_jcm( LONG procno )  ; // post-event-part of c-timig-analyzer ;
EXTERN		DOUBLE                     pow( DOUBLE manti , DOUBLE expo )  ; // optimiert fuer expo ( -8.0 ;-7.75; -7.5; -7.25 ; .... ; 7.5 ; 7.75 ; 8.0 ) ;
EXTERN		LONG                       pre_event_jcm( LONG procno )  ; // pre-event-part of c-timig-analyzer ;
EXTERN		DOUBLE                     psi2bar( DOUBLE psi ) ;
EXTERN		LONG                       puterrorentry3_jcm( CHAR *pfi , CHAR *pfu , LONG line , DOUBLE val1 , DOUBLE val2 , DOUBLE erg , CHAR *pcomm , LONG mode , LONG c_enr , LONG adb_enr )  ; // puterrorentry ;
EXTERN		LONG                       puterrorentry_e_jcm( CHAR *pfi , CHAR *pfu , LONG line , LONG errnr , CHAR *pcomm , LONG mode )  ; // evtl. obsolet ;
EXTERN		LONG                       puterrorentry_jcm( CHAR *pfi , CHAR *pfu , LONG line , DOUBLE val , CHAR *pcomm , LONG mode ) ;
EXTERN		VOID                       puterrorval2_jcm( LONG index , DOUBLE value2 )  ; // set 2. value and time of diag-message ;
EXTERN		DOUBLE                     rad2deg( DOUBLE angle_rad )  ; // radians to degrees ;
EXTERN		ULONG                      rand31_1_jcm( VOID)  ; // 31 bit random number generator ;
EXTERN		ULONG                      rand31_2_jcm( VOID)  ; // 31 bit random number generator ;
EXTERN		VOID                       rand32_init_jcm( LONG sl ) ;
EXTERN		LONG                       rand32_jcm( VOID ) ;
EXTERN		VOID                       rand_cmwc4096_init_jcm( VOID )  ; // init random numbers generator ; algorith : multiply with carry ;
EXTERN		ULONG                      rand_cmwc4096_jcm( VOID )  ; // generate random numbers ; algorith : multiply with carry ;
EXTERN		DOUBLE                     rand_d_lin_kongr_jcm( VOID )  ; // random numbers based upon Kongruenzgenerator ;
EXTERN		VOID                       rand_lin_kongr_init_jcm( ULONG uu )  ; // init Kongruenzgenerator 32 bit ;
EXTERN		DOUBLE                     rand_lin_kongr_jcm( VOID )  ; // random numbers based upon Kongruenzgenerator ;
EXTERN		ULLONG                     rand_lin_kongr_read_ullzz1_jcm( VOID ) ;
EXTERN		ULLONG                     rand_lin_kongr_read_ullzz_jcm( VOID ) ;
EXTERN		VOID                       rand_mwc1038_init_jcm( VOID )  ; // init random numbers generator ; algorith : multiply with carry ;
EXTERN		ULONG                      rand_mwc1038_jcm( VOID )  ; // generate random numbers ; algorith : multiply with carry ;
EXTERN		ULONG                      rand_ul_lin_kongr_jcm( VOID )  ; // ULONG random numbers based upon Kongruenzgenerator ;
EXTERN		VOID                       rand_well1024_init_jcm( VOID ) ;
EXTERN		ULONG                      rand_well1024_jcm( VOID )  ; // random generated , well distributed ;
EXTERN		ULONG                     *rand_well1024state_adr_jcm( VOID )  ; // address of internal register ;
EXTERN		ULONG                      rand_well1024state_size_jcm( VOID )  ; // size in bytes of register ;
EXTERN		ULONG                      rand_xorshift128_jcm( VOID )  ; // random generator , internal 128 bits ;
EXTERN		LONG                       readtimer_dmb_dsb_isb_jcm( VOID ) ;
EXTERN		LONG                       rev_fft_d_jcm( VOID )  ; // FFT-Revision ;
EXTERN		DOUBLE                     round_arm( DOUBLE dv ) ;
EXTERN		LONG                       round_away_zero( DOUBLE dv ) ;
EXTERN		LONG                       round_down( DOUBLE dv ) ;
EXTERN		LONG                       round_to_zero( DOUBLE dv ) ;
EXTERN		LONG                       round_up( DOUBLE dv ) ;
EXTERN		CHAR                      *sec2str_jcm( LONG tt , CHAR *px )  ; // seconds to string ( 12 char   0x00 ) ;
EXTERN		VOID                       set_add_info_txt_jcm( CHAR *p1 , CHAR *p2 , CHAR *p3 , CHAR *p4 , CHAR *p5 )  ;
EXTERN		LONG                       set_cpu_led_jcm( LONG value)  ; // set cpu led ;
EXTERN		VOID                       set_digio_dir_jcm( LONG dignr , LONG output )  ; // set cpu-digio dir ;
EXTERN		VOID                       set_digio_val_jcm( LONG dignr , LONG output )  ; // set cpu-digio val ;
EXTERN		VOID                       set_proc_freq_jcm( DOUBLE f_in_hz )  ; // set process-event frequency ;
EXTERN		VOID                       set_tstamp_jcm( LONG index )  ; // set time stamp ;
EXTERN		VOID                       setadr_jcm( ULONG address , ULONG val )  ; // write val to address ;
EXTERN		VOID                       seterrno2_jcm( LONG c_enr , LONG adbasic_errno )  ; // set c_errorno and adbasic-errorno ;
EXTERN		DOUBLE                     seterrno2nan_jcm( LONG enr , LONG adbasic_errno )  ; // set c_errorno and adbasic-errorno and return a nan ;
EXTERN		VOID                       seterrno_ddbz_jcm( VOID )  ; // seterrno_double_devide_by_zero ;
EXTERN		VOID                       setfpar_jcm( LONG pnr , DOUBLE val )  ; // set FParameter ;
EXTERN		VOID                       setpar_jcm( LONG pnr , LONG val )  ; // set Parameter ;
EXTERN		VOID                       setprocdel_jcm( LONG pnr , LONG delay )  ; // set process delay ;
EXTERN		VOID                       setsilent_jcm( LONG vv )  ; // enable / disable C-errormessages ;
EXTERN		VOID                       setsystemid_jcm( LONG vv ) ;
EXTERN		CHAR                      *setsystemname_jcm( CHAR *pn ) ;
EXTERN		DOUBLE                     si( DOUBLE aa )  ; // sin( aa ) / ( aa ) ;
EXTERN		DOUBLE                     siminf_jcm( VOID )  ; // simulate INF ;
EXTERN		DOUBLE                     simnan_jcm( VOID )  ; // simulate NaN ;
EXTERN		DOUBLE                     sin( DOUBLE dd )  ; // sine ;
EXTERN		DOUBLE                     sinc( DOUBLE aa )  ; // sin( pi *aa ) / ( pi *aa ) ;
EXTERN		DOUBLE                     sinh( DOUBLE vv )  ; // hyperbolic sine ;
EXTERN		DOUBLE                     sqr( DOUBLE vv )  ; // vv *vv ;
EXTERN		DOUBLE                     sqrt( DOUBLE vv )  ; // squareroot with errorhandling ;
EXTERN		DOUBLE                     sqrt_fast( DOUBLE vv )  ; // squareroot fast, without errorhandling ;
EXTERN		LONG                       stack_avail_jcm( LONG pnr )  ; // available stack in bytes of process pnr ;
EXTERN		BOOL                       stack_check_jcm( LONG pnr )  ; // stack check of process pnr ;
EXTERN		LONG                       stack_end_jcm( LONG pnr )  ; // stack end of process pnr ;
EXTERN		LONG                       stack_size_jcm( LONG pnr )  ; // stack size of process pnr ;
EXTERN		CHAR                      *strend_jcm( CHAR *ptxt )  ; // get string end ;
EXTERN		CHAR                      *sysdate2string_jcm( CHAR *pdest )  ; // systemdate -->> string ;
EXTERN		CHAR                      *systime2string_jcm( CHAR *pdest )  ; // system time -->> string ;
EXTERN		LONG                       t0sync1_jcm( LONG dtsoll )  ; // wait until ( now - t0 ) >= dtsoll ;
EXTERN		DOUBLE                     tan( DOUBLE vv )  ; // tangent ;
EXTERN		DOUBLE                     tanh( DOUBLE vv )  ; // hyperbolic tangent ;
EXTERN		DOUBLE                     torr2bar( DOUBLE torr )  ; // torr = mmhg ;
EXTERN		VOID                       track_max_jcm( DOUBLE val , DOUBLE *perg )  ; // track maximum in perg ;
EXTERN		DOUBLE                     triangle( DOUBLE dd )  ; // triangle generator, similar to sin / cos , ampli. = 1.0 ;
EXTERN		DOUBLE                     triangle_ha( DOUBLE vv )  ; // triangle generator, similar to sin / cos , ampli. = pi / 2.0 ;
EXTERN		DOUBLE                     truncate( DOUBLE dv )  ; // Rounds x toward zero, returning the nearest integral ( as double ) value that is not larger in magnitude than x ;
EXTERN		LONG                       tsyncref1_jcm( VOID )  ; // set t0 to now ;
EXTERN		VOID                       udelay_jcm( ULONG usec ) ;
EXTERN		LONG                       updateerrorentry3_jcm( CHAR *pfi , CHAR *pfu , LONG line , DOUBLE val1 , DOUBLE val2 , DOUBLE erg , CHAR *pcomm , LONG mode , LONG c_enr , LONG adb_enr ) ;
EXTERN		DOUBLE                     us_dry_gallon2liter( DOUBLE gal ) ;
EXTERN		DOUBLE                     us_wet_gallon2liter( DOUBLE gal ) ;
EXTERN		VOID                       usleep_jcm( ULONG usec) ;
EXTERN		CHAR                      *ut2str_jcm( LONG ut , CHAR *pd )  ; // unix time to string ( 8 char   0x00 ) ; ( ignoring date ) ;
EXTERN		LONG                       workload1_jcm( VOID )  ; // workload ;
EXTERN		DOUBLE                     yard2meter( DOUBLE yard ) ;
