#ifndef __My_Systwmp_Pointers_Arm_h__
#define __My_Systwmp_Pointers_Arm_h__

// Ptr im Berich von k_MemoryMap_Global_Ptr - (k_MemoryMap_Global_Ptr + 0x10000)
//**++
typedef void *(*My_Malloc_Ptr)(unsigned long , int);
typedef void (*My_Free_Ptr)(void *);
//**--
#ifndef _My_NewLib_LIBRARY_
//**++
typedef void (*MyClear_Process)(int );
typedef void (*MyPrint_Mem_Strukt)(void );
typedef void (*MyInit_Process_struct)(Process_Struct * );
typedef void (*MySingle_Shoot_apic_timer)(long );
typedef void (*MyStart_Process)(int, int );
typedef void (*MyStart_Process_delayed)(int, int ,int);
//**--
#endif //_My_NewLib_LIBRARY_
//**++
typedef void (*My_Serial_Puts)(const char *s);
typedef void (*My_Serial_Puts_Len)(const char *s,int len);
typedef unsigned long long (*My_Read_Global_Timer)(void);
typedef void (*My_Invalidate_DCache_Range)(unsigned long Start, unsigned long Stop);

#define ptr_malloc					( *(My_Malloc_Ptr *)(k_MemoryMap_Global_Ptr + 0x000))
#define ptr_free					(*(My_Free_Ptr *)(k_MemoryMap_Global_Ptr + 0x004))
#define Ptr_Malloc   ptr_malloc      // offiziell dokumentiert laut SJ , 21.01.2014
#define Ptr_Free      ptr_free         // offiziell dokumentiert laut SJ , 21.01.2014
//**--

#ifndef _My_NewLib_LIBRARY_
//**++
#define ptr_Clear_Process			(*(MyClear_Process *)(k_MemoryMap_Global_Ptr + 0x010))
//**--
#define ptr_Print_Mem_Strukt		(*(MyPrint_Mem_Strukt *)	(k_MemoryMap_Global_Ptr + 0x014))
//**++
#define ptr_Init_Process_Struct		(*(MyInit_Process_struct *)	(k_MemoryMap_Global_Ptr + 0x018))
//**--
#define ptr_Single_Shoot_apic_timer	(*(MySingle_Shoot_apic_timer *)(k_MemoryMap_Global_Ptr + 0x01C))
#endif //_My_NewLib_LIBRARY_
//**++
#define Ptr_Serial_Puts				(*(My_Serial_Puts *)			(k_MemoryMap_Global_Ptr + 0x020))
#define Ptr_Serial_Puts_Len			(*(My_Serial_Puts_Len *)		(k_MemoryMap_Global_Ptr + 0x024))
#define Ptr_Read_Global_Timer		(*(My_Read_Global_Timer *)	(k_MemoryMap_Global_Ptr + 0x028))
//**--
#ifndef _My_NewLib_LIBRARY_
#define ptr_Start_Process			(*(MyStart_Process *)	(k_MemoryMap_Global_Ptr + 0x02C))
#define ptr_Start_Process_delayed	(*(MyStart_Process_delayed *)	(k_MemoryMap_Global_Ptr + 0x030))
#define ptr_invalidate_dcache_range	(*(My_Invalidate_DCache_Range *)	(k_MemoryMap_Global_Ptr + 0x034))
#endif //_My_NewLib_LIBRARY_

#endif //__My_Systwmp_Pointers_Arm_h__