'<ADbasic Header, Headerversion 001.001>
'<Header End>
'ADBASIC-SYSTEM-FILE--V1.00--0000--0000--Inc--PRO
#If Processor = T11 Then
#Include ADwinPro1.inc ' all Pro I bus modules with T11
#Include ADwinPro2.inc ' all Pro II bus modules with T11
#Include ADwinPro2tdrv.inc 'Pro II with TiCo
#Else

#If Processor = T12 Then
#Include ADwinPro2arm.inc ' all Pro II bus modules with T12
#include adwinpro2tdrv_arm.inc
import ADwinPro2TDRVLIB_ARM.lic
#else
#Include ADwpAD.inc 'instructions for access to the AD modules T2...T10
#Include ADwpDA.inc 'instructions for access to the DA modules T2...T10
#Include ADwinPro.inc 'system instructions T2...T10
#Include ADwpDIO.inc 'instructions for access to the DIO modules T2...T10
#Include ADwpEXT.inc 'instructions for access to the EXT modules T2...T10

#endif
#EndIf


#if adwin_system=ADwin_GoldII
#error("This include file can only be used with the ADwin ProII or ADwin ProI")  
#endif


#if adwin_system=ADwin_Gold
#error("This include file can only be used with the ADwin ProII or ADwin ProI")  
#endif

#if adwin_system=ADwin_Card
#error("This include file can only be used with the ADwin ProII or ADwin ProI")  
#endif


#if adwin_system=ADwin_L16
#error("This include file can only be used with the ADwin ProII or ADwin ProI")  
#endif



'***************************************************************
''' Converts a process frequency [Hz] into processor ticks (processdelay or cycle time).
''' frequency:  frequency[Hz]
'''*************************************************************
Function Calc_Processdelay(frequency) as long
  
#if prozessor=t12 
  calc_processdelay=1000000000.0/(frequency)
#endif

#if prozessor=t11 
  calc_processdelay=300000000.0/(frequency)
#endif
  

#if prozessor=t10  
#IF PRIORITAET = LOW
  calc_processdelay=20000.0/(frequency)
#else
  calc_processdelay=40000000.0/(frequency)
#endif
#endif

#if prozessor=t9  
#IF PRIORITAET = LOW
  calc_processdelay=10000.0/(frequency)
#else
  calc_processdelay=40000000.0/(frequency)
#endif
#endif
  
endfunction

