#ifndef __FFT_h__
#define __FFT_h__

int FFT_LIB_VERSION_HIGH(void);
void FFT_INIT_HIGH(double* HELP1,double* HELP2,int NUMBER);
void FFT_CALC_HIGH(double* REAL,double* IMG,double* REALZ,double* IMGZ,double* HELP1,double* HELP2,int NUMBER);
void FFT_CALC_DM_HIGH(double* REAL,double* IMG,double* REALZ,double* IMGZ,double* HELP1,double* HELP2,int NUMBER);
void FFT_CALC_DX_HIGH(double* REAL,double* IMG,double* REALZ,double* IMGZ,double* HELP1,double* HELP2,int NUMBER);
void FFT_HIGH(double* REAL,double* IMG,double* REALZ,double* IMGZ,double* HELP1,double* HELP2,int NUMBER);
void FFT_MAG_HIGH(double* REAL,double* IMG,double* RESULT_MAG,int NUMBER2);
void FFT_PHASE_HIGH(double* REAL,double* IMG,double* RESULT_PHASE,int NUMBER2);
void FFT_SCALE_HIGH(double* UNSCALED,double* RESULT_SCALED,int NUMBER2);
void FFT_MAG_SCALE_HIGH(double* REAL_PART,double* IMG_PART,double* RESULT_MAG_SC,int NUMBER2);
int FFT_LIB_VERSION_LOW(void);
void FFT_INIT_LOW(double* HELP1,double* HELP2,int NUMBER);
void FFT_CALC_LOW(double* REAL,double* IMG,double* REALZ,double* IMGZ,double* HELP1,double* HELP2,int NUMBER);
void FFT_CALC_DM_LOW(double* REAL,double* IMG,double* REALZ,double* IMGZ,double* HELP1,double* HELP2,int NUMBER);
void FFT_CALC_DX_LOW(double* REAL,double* IMG,double* REALZ,double* IMGZ,double* HELP1,double* HELP2,int NUMBER);
void FFT_LOW(double* REAL,double* IMG,double* REALZ,double* IMGZ,double* HELP1,double* HELP2,int NUMBER);
void FFT_MAG_LOW(double* REAL,double* IMG,double* RESULT_MAG,int NUMBER2);
void FFT_PHASE_LOW(double* REAL,double* IMG,double* RESULT_PHASE,int NUMBER2);
void FFT_SCALE_LOW(double* UNSCALED,double* RESULT_SCALED,int NUMBER2);
void FFT_MAG_SCALE_LOW(double* REAL_PART,double* IMG_PART,double* RESULT_MAG_SC,int NUMBER2);

#endif //__FFT_h__
